//EXERCICE 1

//Fonction retournant le résultat du test d'indépendance:
function reponse=Chi2Indep(M,alpha)
    k=(size(M,'r')-1)*(size(M,'c')-1);
    Mtheo=sum(M,'c')*sum(M,'r')/sum(M);
    dobs=sum(((M-Mtheo).^2)./Mtheo);
    dlim=cdfchi("X",k,1-alpha,alpha);
    reponse=(dobs<dlim)
endfunction

Msexe=[28,12;25,15];Chi2Indep(Msexe,0.05)
Mbret=[22,18;31,9];Chi2Indep(Mbret,0.05)


//EXERCICE 2

X=rand(1,20);


Y=-gsort(-X)';Y=[Y;1];
n=length(X);
t=zeros(2*n+2,1);Fn=t;
for k=2:2*n+2
    if k/2==floor(k/2) then
        t(k)=Y(k/2);
        Fn(k)=Fn(k-1);
    else
        t(k)=t(k-1);
        Fn(k)=Fn(k-1)+1/n;
    end
end
FU=t;
plot2d(t,[Fn,FU],[2,5])

function reponse=KolSmi(X)
    Y=-gsort(-X)';Y=[Y;1];
    n=length(X);
    t=zeros(2*n+2,1);Fn=t;
    for k=2:2*n+2
      if k/2==floor(k/2) then
          t(k)=Y(k/2);
          Fn(k)=Fn(k-1);
      else
          t(k)=t(k-1);
          Fn(k)=Fn(k-1)+1/n;
      end
    end
    FU=t;
    dobs=max(abs(FU-Fn));
    reponse=(dobs*sqrt(n)<1.36)
endfunction



//EXERCICE 3

////Fonction retournant le résultat du test d'adéquation à une loi
function reponse=Chi2Adeq(Mobs,ptheo,alpha)
    k=length(Mobs)-1;N=sum(Mobs);
    pobs=Mobs/N;
    dobs=N*sum(((pobs-ptheo).^2)./ptheo);
    dlim=cdfchi("X",k,1-alpha,alpha);
    reponse=(dobs<dlim)
endfunction

Mobs=[7,5,5,4,9];ptheo=[0.2,0.2,0.2,0.2,0.2];Chi2Adeq(Mobs,ptheo,alpha)
Mobs=[72,49,48,46,85];Chi2Adeq(Mobs,ptheo,alpha)